odf<-function(tab, ...)
{	
    call<-match.call()
    if((length(call)==2)&&(is.odf(tab))) return(tab)
    #if((is.numeric(tab))&&(length(dim(tab)))==2) {
    if(length(dim(tab))==2) {	
        if((is.otab(tab))||((all(apply(tab,1,sum)==1))&&(all(as.matrix(tab)%in%c(0,1))))) {
            x<-as.otab(tab)
            #odf<-subset(as.data.frame.table(x),Freq==1)[2]
			odf<-subset(as.data.frame.table(t(x)),Freq==1)[1]
            names(odf)<-c(paste(call[[2]],".col",sep=""))
        }
        else {
            x<-as.data.frame.table(as.matrix(tab))
            row.fac<-rep(x$Var1,x$Freq)
            col.fac<-rep(x$Var2,x$Freq)
            odf<-data.frame(col.fac,row.fac)
            if("$"%in%paste(call[[2]])) 
                names(odf)<-c(paste(call[[2]][length(call[[2]])],".col",sep=""),paste(call[[2]][length(call[[2]])],".row",sep=""))
            else names(odf)<-c(paste(call[2],".col",sep=""),paste(call[2],".row",sep=""))
        }
        if(length(call)>2) {
            if(nrow(tab)!=nrow(y<-data.frame(...))) stop("non convenient dimensions")
            if(is.otab(x)) {
                odf<-cbind(odf,y)
                names(odf)<-c(names(odf)[1],names(y))
            }
            else {
                for(i in 1:ncol(y)) odf<-cbind(odf,rep(y[x$Var1,i],x$Freq))
                names(odf)<-c(names(odf)[1:2],names(y))
            }    
        }
    }
    else stop("cannot coerce into 'odf'")
    class(odf)<-c("odf",class(odf))
    return(odf)
}

as.odf<-function(..., sp.fac=1)
{
    odf<-data.frame(...)
    if(sp.fac!=1) {
        t<-as.factor(odf[,sp.fac])
        nmt<-names(odf)[sp.fac]
        odf<-subset(odf,select=-sp.fac)
        odf<-cbind(t,odf)
        names(odf)[1]<-nmt
    }
    class(odf)<-c("odf",class(odf))
    return(odf)
}

is.odf<-function(x) inherits(x,"odf")

summary.odf<-function(x,sp.fac=1)
{
    cat("Occurrence data frame summary")
    cat("\nclass: ")
    cat(class(x))
    cat("\nnumber of occurences: ")
    cat(nrow(x))
    cat("\nnumber of variables: ")
    cat(ncol(x))
    cat("\n\n")
    print(summary.data.frame(x))
    cat(c("\nSpecies occurrence data: ",names(x)[sp.fac]))
    cat("\n")
    f<-function(a) return(signif(a,digit=3))
    cw<-table(x[,sp.fac])/nrow(x)
    res<-alist()
    res$SV<-cw*(1-cw)
    res$DT<-c(Richness=sum(1-cw,na.rm=TRUE),Shannon=sum(log(1/cw)*cw,na.rm=TRUE),Simpson=sum(cw*(1-cw),na.rm=TRUE))
    sumry<-array("",c(3,2),list(1:3,c("","DT")))
    sumry[1,]<-c("Richness",f(res$DT[1]))
    sumry[2,]<-c("Shannon",f(res$DT[2]))
    sumry[3,]<-c("Simpson",f(res$DT[3]))
    class(sumry)<-"table"
    print(sumry)
    cat("\n")
    invisible(res)
}
